
#define INCL_WIN
#define INCL_GPI
#define INCL_DOS
#define INCL_DOSERRORS

#include <os2.h>
#include "gradd.h"
#include "mgadive.h"


extern GID gidEN;
extern BOOL fCursorInit;
extern FNHWENTRY *pfnChainedHWEntry;
extern ULONG VramHandle;

ULONG EXPENTRY HWEntry( GID gid, ULONG ulFun, PVOID pIn, PVOID pOut ) {
        if ( fCursorInit == FALSE )
        {
            VHLockMem(&gidEN,
                      0x1000, /* our GRADD very small, so one-page size suitable */
                      TRUE );
            VHLockMem((PVOID)HWEntry,
                      0x2000, /* our GRADD very small, but two-page size needed */
                      FALSE );
            fCursorInit = TRUE;
        }

   if (ulFun==GHI_CMD_INIT) {
            /* save our gid*/
            gidEN = gid;
            /* save entry point of lower GRADD */
            pfnChainedHWEntry = ((PGDDINITIN)pIn)->pfnChainedHWEntry;
            if (((PGDDINITOUT)pOut)->ulLength >= sizeof(GDDINITOUT))
               ((PGDDINITOUT)pOut)->cFunctionClasses = 1;
            return CheckHardware(); /* Check presence of apropriate HW */
        }
   /* if this is our request*/

   if (gid == gidEN) {
      switch (ulFun)   {
        case GHI_CMD_QUERYCAPS:
                ((PCAPSINFO)pOut)->ulLength=sizeof(CAPSINFO);
                ((PCAPSINFO)pOut)->pszFunctionClassID=VA1_FUNCTION_CLASS;
                ((PCAPSINFO)pOut)->ulFCFlags=0;
                return RC_SUCCESS;
        case GHI_CMD_QUERYMODES:
                if (*(PULONG)pIn == QUERYMODE_NUM_MODES)
                    *(PULONG)pOut=0;
                return RC_SUCCESS;
        case GHI_CMD_EXTENSION:
                return HWExtension((PHWEXTENSION)pIn,pOut);
        case GHI_CMD_INITPROC:
                return RC_SUCCESS;
        default:
                return RC_UNSUPPORTED;
        }
      }
   /* we need to support GHI_CMD_VRAM, because without it
    * dive.dll unable to use accelerator */
   if ((gid==0)&&(ulFun==GHI_CMD_VRAM)) {
      return HWVRAM((PVRAMIN)pIn,pOut);
      }
   /* we need to check GHI_CMD_EVENT to enable/disable video output*/
   if ((gid==0)&&(ulFun==GHI_CMD_EVENT)) {
      return HWEVENT((PHWEVENTIN)pIn);
      }
   return pfnChainedHWEntry(gid,ulFun,pIn,pOut);
}


